package jp.ne.ruru.park.ando.memoswing.core.editors;
import java.awt.Color;
import java.util.ArrayList;
import java.util.List;

import javax.swing.SwingUtilities;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;
import javax.swing.text.AttributeSet;
import javax.swing.text.BadLocationException;
import javax.swing.text.DefaultStyledDocument;
import javax.swing.text.StyleConstants;

/**
 * ƂɂȂ낤phLg
 * @author 
 *
 */
@SuppressWarnings("serial")
public class MemoStyledDocument extends DefaultStyledDocument {
	/** RXgN^ */
	public MemoStyledDocument() {
        super();
        //
        // J[Oݒ
        this.keyword = new Token();
        this.space = new Token();
        this.comment = new Token();
        this.keyword.addAttribute(StyleConstants.Foreground, new Color(  0,  0,255));
        this.comment.addAttribute(StyleConstants.Foreground, new Color(128,128,  0));
        this.space.addAttribute(StyleConstants.Background, new Color(192,192, 255));
        //
        // [̔zu
        this.rules = new ArrayList<IRule>();
        this.rules.add(new MemoCommentRule(comment));
        this.rules.add(new MemoRubiRule(keyword));
        this.rules.add(new MemoSpaceRule(space));
        //
        // Xi[ݒ
        this.addDocumentListener(dListener);
    }
	/**
	 * Xi[ݒ
	 */
	protected DocumentListener dListener = new DocumentListener() {
		/*
		 * (non-Javadoc)
		 * @see javax.swing.event.DocumentListener#insertUpdate(javax.swing.event.DocumentEvent)
		 */
        @Override
        public void insertUpdate(DocumentEvent e) {
            runMemo(e);
        }
        /*
         * (non-Javadoc)
         * @see javax.swing.event.DocumentListener#removeUpdate(javax.swing.event.DocumentEvent)
         */
        @Override
        public void removeUpdate(DocumentEvent e) {
            runMemo(e);
        }
        /*
         * (non-Javadoc)
         * @see javax.swing.event.DocumentListener#changedUpdate(javax.swing.event.DocumentEvent)
         */
        @Override
        public void changedUpdate(DocumentEvent e) {
            runMemo(e);
        }
	};
	/**
	 * U󂯂āAswingXbh̍Ōɉ
	 * @param e Cxg
	 * @param listener Xi[
	 */
    protected void runMemo(DocumentEvent e) {
        SwingUtilities.invokeLater(()->this.nextMemo(e));
    }
	/**
	 * Ys̐FÂς
	 * @param event Cxg
	 * @param listener Xi[
	 */
    protected void nextMemo(DocumentEvent event) {
        this.removeDocumentListener(dListener);
        try {
        	//
        	int offset = event.getOffset();
        	int max = offset + event.getLength();
            String string;
            // s[ɂȂ܂ők
            for (; (0 <= offset - 1) && (0 < this.getLength()) ; offset--) {
                string = this.getText(offset - 1, 1);
                char ch = string.charAt(0);
                if ((ch == '\r') || (ch == '\n')) {
                    break;
                }
            }
            // smax܂ŐL΂
            for (; max < this.getLength() ; max++) {
                string = this.getText(max, 1);
                char ch = string.charAt(0);
                if ((ch == '\r') || (ch == '\n')) {
                    break;
                }
            }
            // ől͕񒷂菬
            if (this.getLength() < max) {
                max = this.getLength();
            }
            // XL̗p
            string = this.getText(offset, max - offset);
            CharacterScanner scanner = new CharacterScanner(string);
            int undefLen = 0;
            int undefOffset = 0;
            //
            // SXL
            for (int i = 0 ; i < string.length() ; i++) {
            	//
            	// [Ƀqbĝ邩mF
                IToken nextToken = Token.UNDEFINED;
                for (IRule rule : rules) {
                    scanner.setOffset(i);
                    scanner.setLength(0);
                    nextToken = rule.evaluate(scanner);
                    if (!nextToken.equals(Token.UNDEFINED)) {
                        break;
                    }
                }
                if (!nextToken.equals(Token.UNDEFINED)) {
                	// qbĝ
                	if (0 < undefLen) {
                		// ftHg̍XV
                        this.setCharacterAttributes(offset + undefOffset,undefLen, (AttributeSet)Token.UNDEFINED.getData(), true);
                        undefLen = 0;
                	}
                	// qbĝ̐FXV
                    int len = scanner.getLength();
                    this.setCharacterAttributes(offset + i,len, (AttributeSet)nextToken.getData(), true);
                    i = i + len - 1;
                    undefOffset = i + 1;
                } else {
                	// qbĝ͂Ȃ
                	undefLen++;
                }
            }
        	if (0 < undefLen) {
                this.setCharacterAttributes(offset + undefOffset,undefLen, (AttributeSet)Token.UNDEFINED.getData(), true);
                undefLen = 0;
        	}
        } catch (BadLocationException e) {
            e.printStackTrace();
        } finally {
        	this.addDocumentListener(dListener);
        }
    }
    /** L[[hpg[N */
    private final Token keyword;
    /** Xy[Xpg[N */
    private final Token space;
    /** Rgpg[N */
    private final Token comment;
    /** [ */
    private final List<IRule> rules;
}
